## netgen 6.2.2006+really6.2.1905+dfsg

=== CMakeLists.txt ===
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING INTERNAL)
endif(NOT CMAKE_BUILD_TYPE)

if(WIN32)
  # we are linking to object libraries on Windows
  cmake_minimum_required(VERSION 3.12)
else(WIN32)
  cmake_minimum_required(VERSION 3.1.3)
endif(WIN32)

if(NOT WIN32)
    option( USE_NATIVE_ARCH  "build which -march=native" ON)
endif(NOT WIN32)

option( USE_GUI     "don't build netgen with GUI" ON )
option( USE_PYTHON  "build with python interface" ON )
option( USE_MPI     "enable mpi parallelization" OFF )
option( USE_OCC     "(not supported) compile with OpenCascade geometry kernel" OFF)
option( USE_JPEG    "enable snapshots using library libjpeg" OFF )
option( USE_MPEG    "enable video recording with FFmpeg, uses libavcodec" OFF )
option( INTEL_MIC        "cross compile for intel xeon phi")
option( INSTALL_PROFILES "install environment variable settings to /etc/profile.d" OFF )
option( USE_CCACHE       "use ccache")
option( USE_INTERNAL_TCL "Compile tcl files into the code and don't install them" ON)
option( ENABLE_UNIT_TESTS "Enable Catch unit tests")
option( ENABLE_CPP_CORE_GUIDELINES_CHECK "Enable cpp core guideline checks on ngcore" OFF)
option( USE_SPDLOG "Enable spd log logging" OFF)
option( DEBUG_LOG "Enable more debug output (may increase computation time) - only works with USE_SPDLOG=ON" OFF)
option( CHECK_RANGE "Check array range access, automatically enabled if built in debug mode" OFF)

option( USE_SUPERBUILD       "use ccache" ON)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_modules")

if(APPLE)
  set(INSTALL_DIR_DEFAULT /Applications/Netgen.app)
else(APPLE)
  if(WIN32)
    set(INSTALL_DIR_DEFAULT "C:/netgen")
  else(WIN32)
    set(INSTALL_DIR_DEFAULT /opt/netgen)
  endif(WIN32)
endif(APPLE)

if(INSTALL_DIR)
  message(WARNING "INSTALL_DIR is deprecated, use CMAKE_INSTALL_PREFIX instead")
  set(INSTALL_DIR_DEFAULT ${INSTALL_DIR})
endif(INSTALL_DIR)

if(UNIX)
  message("Checking for write permissions in install directory...")
  execute_process(COMMAND mkdir -p ${CMAKE_INSTALL_PREFIX})
  execute_process(COMMAND test -w ${CMAKE_INSTALL_PREFIX} RESULT_VARIABLE res)
  if(res)
    message(WARNING "No write access at install directory, please set correct permissions")
  endif()
endif(UNIX)

if (USE_SUPERBUILD)
  project (SUPERBUILD)
  if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${INSTALL_DIR_DEFAULT}" CACHE PATH "Install directory" FORCE)
  endif()

  # execute the superbuild (this script will be invoked again without the
  # USE_SUPERBUILD option this time)
  include (cmake/SuperBuild.cmake)
  return()                      # stop processing this file further
else()
  project(Netgen)
  if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${INSTALL_DIR_DEFAULT}" CACHE PATH "Install directory" FORCE)
  endif()
endif()

set(NETGEN_VERSION_MAJOR 6)
set(NETGEN_VERSION_MINOR 2)
string(TIMESTAMP NETGEN_VERSION_PATCH "%y%U%w" )
set(NETGEN_VERSION "${NETGEN_VERSION_MAJOR}.${NETGEN_VERSION_MINOR}-dev")
set(PACKAGE_VERSION "${NETGEN_VERSION_MAJOR}.${NETGEN_VERSION_MINOR}-${NETGEN_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION "${PACKAGE_VERSION}")


#######################################################################
if(USE_CCACHE)
  find_program(CCACHE_FOUND NAMES ccache ccache.bat)
  if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_FOUND})
  endif(CCACHE_FOUND)
endif(USE_CCACHE)

#######################################################################
if(USE_NATIVE_ARCH)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
endif(USE_NATIVE_ARCH)

#######################################################################
if(INTEL_MIC)
    set(MKL_ARCH "mic")
    include(cmake/mic.cmake)
else(INTEL_MIC)
    set(MKL_ARCH "intel64")
endif(INTEL_MIC)

#######################################################################
# Append install paths of software in non-standard paths (e.g. openmpi, metis, intel mkl, ...)
# cmake -DUSE_MPI=ON -DCMAKE_PREFIX_PATH="/opt/openmpi165;/opt/metis51" ../
set(ADDITIONAL_PATHS "" CACHE PATH "List of paths to additional libraries in non-standard locations, separated by ';'")
if (ADDITIONAL_PATHS)
  set(CMAKE_PREFIX_PATH ${ADDITIONAL_PATHS})
endif (ADDITIONAL_PATHS)

#######################################################################
# build options
include_directories ("${PROJECT_SOURCE_DIR}/include")
include_directories ("${PROJECT_SOURCE_DIR}/libsrc/include")
include_directories ("${PROJECT_BINARY_DIR}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(USE_PYTHON)
    find_package(PythonInterp 3 REQUIRED)
    find_package(PythonLibs 3 REQUIRED)

    execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1,0,''))" OUTPUT_VARIABLE PYTHON_PACKAGES_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    file(TO_CMAKE_PATH ${PYTHON_PACKAGES_INSTALL_DIR} PYTHON_PACKAGES_INSTALL_DIR)
endif(USE_PYTHON)

set(NG_INSTALL_SUFFIX netgen CACHE STRING "Suffix appended to install directories (project name)")

if(APPLE)
  set(NG_INSTALL_DIR_BIN_DEFAULT Contents/MacOS)
  set(NG_INSTALL_DIR_LIB_DEFAULT Contents/MacOS)
  set(NG_INSTALL_DIR_CMAKE_DEFAULT Contents/Resources/CMake)
  set(NG_INSTALL_DIR_PYTHON_DEFAULT Contents/Resources/${PYTHON_PACKAGES_INSTALL_DIR})
  set(NG_INSTALL_DIR_RES_DEFAULT Contents/Resources/share)
  set(NG_INSTALL_DIR_INCLUDE_DEFAULT Contents/Resources/include)

  set(NG_RPATH_TOKEN "@loader_path")
else(APPLE)
  set(NG_INSTALL_DIR_BIN_DEFAULT bin)
  set(NG_INSTALL_DIR_LIB_DEFAULT lib)
  if(WIN32)
    set(NG_INSTALL_DIR_CMAKE_DEFAULT cmake)
  else(WIN32)
    set(NG_INSTALL_DIR_CMAKE_DEFAULT lib/cmake/${NG_INSTALL_SUFFIX})
  endif(WIN32)
  set(NG_INSTALL_DIR_PYTHON_DEFAULT ${PYTHON_PACKAGES_INSTALL_DIR})
  set(NG_INSTALL_DIR_RES_DEFAULT share)
  set(NG_INSTALL_DIR_INCLUDE_DEFAULT include)

  set(NG_RPATH_TOKEN "\$ORIGIN")
endif(APPLE)

set(NG_INSTALL_DIR_PYTHON ${NG_INSTALL_DIR_PYTHON_DEFAULT} CACHE STRING "Install directory for Python files")
set(NG_INSTALL_DIR_BIN ${NG_INSTALL_DIR_BIN_DEFAULT} CACHE STRING "Install directory for executables")
set(NG_INSTALL_DIR_LIB ${NG_INSTALL_DIR_LIB_DEFAULT} CACHE STRING "Install directory for libraries")
set(NG_INSTALL_DIR_INCLUDE ${NG_INSTALL_DIR_INCLUDE_DEFAULT} CACHE STRING "Install directory for header files")
set(NG_INSTALL_DIR_CMAKE ${NG_INSTALL_DIR_CMAKE_DEFAULT} CACHE STRING "Install directory for CMake files")
set(NG_INSTALL_DIR_RES ${NG_INSTALL_DIR_RES_DEFAULT} CACHE STRING "Install directory for resources")

get_filename_component(NETGEN_CMAKE_DIR_ABSOLUTE ${NG_INSTALL_DIR_CMAKE} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_BINARY_DIR_ABSOLUTE ${NG_INSTALL_DIR_BIN} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_LIBRARY_DIR_ABSOLUTE ${NG_INSTALL_DIR_LIB} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_INCLUDE_DIR_ABSOLUTE ${NG_INSTALL_DIR_INCLUDE} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_RESOURCE_DIR_ABSOLUTE ${NG_INSTALL_DIR_RES} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})

file(RELATIVE_PATH NETGEN_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${CMAKE_INSTALL_PREFIX})
file(RELATIVE_PATH NETGEN_BINARY_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_BINARY_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_LIBRARY_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_INCLUDE_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_INCLUDE_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_RESOURCE_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_RESOURCE_DIR_ABSOLUTE})

file(RELATIVE_PATH NETGEN_RPATH ${NETGEN_BINARY_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})

if(USE_PYTHON)
    get_filename_component(NETGEN_PYTHON_DIR_ABSOLUTE ${NG_INSTALL_DIR_PYTHON} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
    file(RELATIVE_PATH NETGEN_PYTHON_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_PYTHON_DIR_ABSOLUTE})
    file(RELATIVE_PATH NETGEN_PYTHON_RPATH_BIN ${NETGEN_PYTHON_DIR_ABSOLUTE} ${NETGEN_BINARY_DIR_ABSOLUTE})
    file(RELATIVE_PATH NETGEN_PYTHON_RPATH ${NETGEN_PYTHON_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})
    if(WIN32)
        set(NETGEN_PYTHON_RPATH ${NETGEN_PYTHON_RPATH_BIN})
    endif(WIN32)
endif(USE_PYTHON)

set(NG_INSTALL_DIR EXPORT netgen-targets RUNTIME DESTINATION ${NG_INSTALL_DIR_BIN} COMPONENT netgen LIBRARY DESTINATION ${NG_INSTALL_DIR_LIB} COMPONENT netgen_devel ARCHIVE DESTINATION ${NG_INSTALL_DIR_LIB} COMPONENT netgen_devel)
install(EXPORT netgen-targets DESTINATION ${NG_INSTALL_DIR_CMAKE} COMPONENT netgen_devel)

set(CMAKE_MACOSX_RPATH TRUE)
set(CMAKE_INSTALL_RPATH "${NG_RPATH_TOKEN};${NG_RPATH_TOKEN}/${NETGEN_RPATH}")

include (CheckIncludeFiles)
check_include_files (dlfcn.h HAVE_DLFCN_H)
if(HAVE_DLFCN_H)
  add_definitions(-DHAVE_DLFCN_H)
endif()
add_definitions(-DNETGEN_VERSION="${NETGEN_VERSION}")

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

#######################################################################
# platform specific definitions and flags
macro(get_WIN32_WINNT version)
    if (WIN32 AND CMAKE_SYSTEM_VERSION)
        if("${CMAKE_SYSTEM_VERSION}" MATCHES "^([0-9]+)\\.([0-9]+)")
            math(EXPR ver "${CMAKE_MATCH_1}*100 + ${CMAKE_MATCH_2}")
        endif()
        set(${version} "0x${ver}")
    endif()
endmacro()

macro(get_dll_from_lib dll_path lib_path)
        get_filename_component(parent_lib_path ${lib} DIRECTORY)
        get_filename_component(lib_name ${lib} name)
endmacro()

set(CMAKE_CXX_STANDARD 14)
if(WIN32)
    get_WIN32_WINNT(ver)
    add_definitions(-D_WIN32_WINNT=${ver} -DWNT -DWNT_WINDOW -DNOMINMAX)
    set(CMAKE_MFC_FLAG 0)
    add_definitions(-DMSVC_EXPRESS -D_CRT_SECURE_NO_WARNINGS -DHAVE_STRUCT_TIMESPEC)
    # build convenience (aka object) libraries in windows)
    set(NG_LIB_TYPE OBJECT)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4244 /wd4800")
else(WIN32)
    # build shared libraries
    set(NG_LIB_TYPE SHARED)
endif(WIN32)
if(APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -undefined dynamic_lookup")
endif(APPLE)

#######################################################################
if(NOT ZLIB_INCLUDE_DIRS)
  find_package(ZLIB REQUIRED)
endif(NOT ZLIB_INCLUDE_DIRS)
include_directories(${ZLIB_INCLUDE_DIRS})

#######################################################################
if (USE_GUI)
    find_package(TCL 8.5 REQUIRED)
    find_package(Threads REQUIRED)
    if(APPLE)
          set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -framework AppKit")
    else(APPLE)
          find_package(X11 REQUIRED) 
    endif(APPLE)
    find_package(OpenGL REQUIRED)

    add_definitions(-DTCL -DOPENGL -DUSE_TOGL_2)
    include_directories(${TCL_INCLUDE_PATH})
    include_directories(${TK_INCLUDE_PATH})
    set(LIBTOGL togl)

    if(WIN32)
        add_definitions(-DTOGL_WGL)
    else(WIN32)
        if(APPLE)
                ADD_DEFINITIONS(-DTOGL_NSOPENGL)
        else(APPLE)
                ADD_DEFINITIONS(-DTOGL_X11)
        endif(APPLE)
    endif(WIN32)
endif (USE_GUI)

#######################################################################
if (USE_PYTHON)
    add_subdirectory(external_dependencies/pybind11)
    add_definitions(-DNG_PYTHON)
    find_path(PYBIND_INCLUDE_DIR pybind11/pybind11.h HINTS ${PYTHON_INCLUDE_DIR})
    if( PYBIND_INCLUDE_DIR )
        message(STATUS "Found Pybind11: ${PYBIND_INCLUDE_DIR}")
    else( PYBIND_INCLUDE_DIR )
        message(FATAL_ERROR "Could NOT find pybind11!")
    endif( PYBIND_INCLUDE_DIR )

    include_directories(${PYBIND_INCLUDE_DIR})
    include_directories(${PYTHON_INCLUDE_DIRS})

    if(NG_INSTALL_PYBIND)
      install(DIRECTORY ${PYBIND_INCLUDE_DIR}/pybind11 DESTINATION ${NG_INSTALL_DIR_INCLUDE} COMPONENT netgen_devel)
      install(FILES ${PYBIND_INCLUDE_DIR}/../LICENSE DESTINATION ${NG_INSTALL_DIR_INCLUDE}/pybind11 COMPONENT netgen_devel)

=== doc/CMakeLists.txt ===
INSTALL(FILES ng4.pdf DESTINATION ${NG_INSTALL_DIR_RES}/${NG_INSTALL_SUFFIX}/doc COMPONENT netgen_doc)

=== libsrc/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(general)
add_subdirectory(gprim)
add_subdirectory(linalg)
add_subdirectory(include)
add_subdirectory(meshing)
add_subdirectory(visualization)
add_subdirectory(csg)
add_subdirectory(geom2d)
add_subdirectory(occ)
add_subdirectory(stlgeom)
add_subdirectory(interface)

=== ng/CMakeLists.txt ===
if(USE_INTERNAL_TCL)
  add_definitions(-DINTERNAL_TCL_DEFAULT=1)
else()
  add_definitions(-DINTERNAL_TCL_DEFAULT=0)
endif()

set(netgen_sources ngappinit.cpp onetcl.cpp)
if(WIN32)
    # add icon to netgen executable
    enable_language(RC)
    set(netgen_sources ${netgen_sources} ../windows/netgen.rc)
    # Don't use ccache here due to incompatibility with the resource compiler
    set_directory_properties(PROPERTIES RULE_LAUNCH_COMPILE "")
endif(WIN32)

if(USE_GUI)

    add_library(gui SHARED
        gui.cpp ngpkg.cpp demoview.cpp parallelfunc.cpp
        ../libsrc/stlgeom/stlpkg.cpp ../libsrc/visualization/visualpkg.cpp
        ../libsrc/csg/csgpkg.cpp ../libsrc/geom2d/geom2dpkg.cpp
        ../libsrc/occ/occpkg.cpp ../libsrc/occ/vsocc.cpp
    )

    add_executable(netgen ngappinit.cpp onetcl.cpp)

    target_link_libraries( gui PUBLIC nglib )
    target_link_libraries( gui PRIVATE ${LIBTOGL} ${ZLIB_LIBRARIES} ${JPEG_LIBRARIES} ${FFMPEG_LIBRARIES} ${X11_Xmu_LIB} ${X11_X11_LIB} ${OCC_LIBRARIES} )
    if(NOT APPLE)
      target_link_libraries( gui PRIVATE ${TCL_LIBRARY} ${TK_LIBRARY})
    endif(NOT APPLE)

    target_link_libraries( netgen nglib gui ${LIBTOGL} ${ZLIB_LIBRARIES} ${JPEG_LIBRARIES} ${FFMPEG_LIBRARIES} ${X11_Xmu_LIB} ${X11_X11_LIB} ${OCC_LIBRARIES} ${TK_LIBRARY} ${TCL_LIBRARY} ${PYTHON_LIBRARIES})

    if(NOT WIN32)
      target_link_libraries( netgen mesh stlvis stl geom2dvis interface geom2d csg stl visual csgvis )
      target_link_libraries( gui PUBLIC mesh stlvis stl geom2dvis interface geom2d csg stl visual csgvis )
    endif(NOT WIN32)

    install(TARGETS netgen ${NG_INSTALL_DIR})
    install(TARGETS gui ${NG_INSTALL_DIR})

    if(APPLE)
        set_target_properties(netgen PROPERTIES OUTPUT_NAME netgen)
    endif(APPLE)
    if(WIN32)
        set_target_properties( gui PROPERTIES OUTPUT_NAME libgui )
    endif(WIN32)
    target_link_libraries( gui PRIVATE ${PYTHON_LIBRARIES})

endif(USE_GUI)

if(USE_PYTHON)
    add_library(ngpy SHARED netgenpy.cpp)
    target_link_libraries( ngpy PUBLIC nglib PRIVATE ${PYTHON_LIBRARIES})
    if(APPLE)
        set_target_properties( ngpy PROPERTIES SUFFIX ".so")
    elseif(WIN32)
        set_target_properties( ngpy PROPERTIES SUFFIX ".pyd")
        set_target_properties( ngpy PROPERTIES OUTPUT_NAME "libngpy")
    endif()
    set_target_properties(ngpy PROPERTIES INSTALL_RPATH "${NG_RPATH_TOKEN}/../${NETGEN_PYTHON_RPATH}")
    install(TARGETS ngpy DESTINATION ${NG_INSTALL_DIR_PYTHON}/${NG_INSTALL_SUFFIX} COMPONENT netgen)
endif(USE_PYTHON)

if(USE_GUI)
  if(NOT USE_INTERNAL_TCL)
    install(FILES
        dialog.tcl menustat.tcl ngicon.tcl ng.tcl
        ngvisual.tcl sockets.tcl nghelp.tcl ngshell.tcl
        ngtesting.tcl parameters.tcl variables.tcl csgeom.tcl stlgeom.tcl
        occgeom.tcl acisgeom.tcl netgen.ocf drawing.tcl
        DESTINATION ${NG_INSTALL_DIR_BIN} COMPONENT netgen)
  endif()

  add_subdirectory(Togl2.1)
endif(USE_GUI)

=== nglib/CMakeLists.txt ===
add_definitions(-DNGLIB_EXPORTS)

if(WIN32)
    set(nglib_objects 
          $<TARGET_OBJECTS:mesh>
          $<TARGET_OBJECTS:stl>
          $<TARGET_OBJECTS:interface>
          $<TARGET_OBJECTS:geom2d>
          $<TARGET_OBJECTS:csg>
          $<TARGET_OBJECTS:stl>

          $<TARGET_OBJECTS:visual>
          $<TARGET_OBJECTS:occ>
       )
       if(USE_GUI)
           set(nglib_objects ${nglib_objects}
	       $<TARGET_OBJECTS:stlvis>
	       $<TARGET_OBJECTS:geom2dvis>
               $<TARGET_OBJECTS:csgvis>
           )
       endif(USE_GUI)
endif(WIN32)

add_library(nglib SHARED nglib.cpp ${nglib_objects})
if(NOT WIN32)
      target_link_libraries( nglib PUBLIC mesh stl interface geom2d csg stl visual)
      if(USE_GUI)
          target_link_libraries( nglib PUBLIC stlvis geom2dvis csgvis )
      endif(USE_GUI)
endif(NOT WIN32)

# target_link_libraries(nglib PRIVATE gen la gprim PUBLIC ngcore)
target_link_libraries(nglib PUBLIC ngcore)

target_link_libraries( nglib PRIVATE ${OCC_LIBRARIES} ${MPI_CXX_LIBRARIES} ${OPENGL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${X11_Xmu_LIB} ${JPEG_LIBRARIES} ${MKL_LIBRARIES} ${ZLIB_LIBRARIES} ${OCC_LIBRARIES} )

if(USE_OCC AND NOT WIN32)
    target_link_libraries(nglib PUBLIC occ)
endif(USE_OCC AND NOT WIN32)

if(USE_PYTHON)
    target_link_libraries(nglib PRIVATE ${PYTHON_LIBRARIES})
endif(USE_PYTHON)

install(TARGETS nglib ${NG_INSTALL_DIR})
install(FILES nglib.h DESTINATION ${NG_INSTALL_DIR_INCLUDE} COMPONENT netgen_devel)

=== python/CMakeLists.txt ===
if(USE_GUI)
  set(IMPORT_TKINTER True)
else()
  set(IMPORT_TKINTER False)
endif()
configure_file(__init__.py ${CMAKE_CURRENT_BINARY_DIR}/__init__.py @ONLY)

install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/__init__.py
        meshing.py csg.py geom2d.py stl.py gui.py NgOCC.py read_gmsh.py
        DESTINATION ${NG_INSTALL_DIR_PYTHON}/${NG_INSTALL_SUFFIX}
        COMPONENT netgen
        )

=== tests/CMakeLists.txt ===
add_subdirectory(catch)
add_subdirectory(pytest)

=== tutorials/CMakeLists.txt ===
install( FILES 
        boxcyl.geo circle_on_cube.geo cone.geo cube.geo			   
        cubeandring.geo cubeandspheres.geo cubemcyl.geo cubemsphere.geo cylinder.geo	   
        cylsphere.geo ellipsoid.geo ellipticcyl.geo extrusion.geo fichera.geo lshape3d.geo 
        manyholes.geo manyholes2.geo matrix.geo ortho.geo period.geo revolution.geo	   
        sculpture.geo shaft.geo shell.geo sphere.geo sphereincube.geo torus.geo trafo.geo  
        twobricks.geo twocubes.geo twocyl.geo boundarycondition.geo			   
        hinge.stl  part1.stl frame.step  screw.step					   
        squarehole.in2d squarecircle.in2d square.in2d
        DESTINATION ${NG_INSTALL_DIR_RES}/${NG_INSTALL_SUFFIX}
        COMPONENT netgen_tutorial
       )

=== libsrc/core/CMakeLists.txt ===

add_library(ngcore SHARED archive.cpp logging.cpp paje_trace.cpp utils.cpp profiler.cpp)

target_compile_definitions(ngcore PRIVATE NGCORE_EXPORTS)
if(NOT WIN32)
  target_compile_options(ngcore PRIVATE -fvisibility=hidden)
endif(NOT WIN32)

target_compile_definitions(ngcore PUBLIC $<$<CONFIG:DEBUG>:NETGEN_ENABLE_CHECK_RANGE>)

if(CHECK_RANGE)
  target_compile_definitions(ngcore PUBLIC NETGEN_ENABLE_CHECK_RANGE)
endif(CHECK_RANGE)

if(USE_SPDLOG)
  include_directories(${SPDLOG_INCLUDE_DIR})
  install(DIRECTORY ${SPDLOG_INCLUDE_DIR}
    DESTINATION ${NG_INSTALL_DIR_INCLUDE}
    )
  add_dependencies(ngcore project_spdlog)
  target_compile_definitions(ngcore PUBLIC NETGEN_USE_SPDLOG)
  if(DEBUG_LOG)
    target_compile_definitions(ngcore PUBLIC NETGEN_LOG_DEBUG)
  endif(DEBUG_LOG)
endif(USE_SPDLOG)

install(TARGETS ngcore DESTINATION ${NG_INSTALL_DIR} COMPONENT netgen)

if(USE_PYTHON)
  target_compile_definitions(ngcore PUBLIC NETGEN_PYTHON)
  target_include_directories(ngcore PRIVATE ${PYTHON_INCLUDE_DIRS})
  target_link_libraries(ngcore PRIVATE ${PYTHON_LIBRARIES})
endif(USE_PYTHON)

install(FILES ngcore.hpp archive.hpp type_traits.hpp version.hpp ngcore_api.hpp logging.hpp
  exception.hpp symboltable.hpp paje_trace.hpp utils.hpp profiler.hpp mpi_wrapper.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/core COMPONENT netgen_devel)

if(ENABLE_CPP_CORE_GUIDELINES_CHECK)
  set_target_properties(ngcore PROPERTIES CXX_CLANG_TIDY "${DO_CLANG_TIDY}")
endif(ENABLE_CPP_CORE_GUIDELINES_CHECK)

if(USE_PYTHON)
  pybind11_add_module(pyngcore SHARED python_ngcore.cpp)
  target_link_libraries(pyngcore PUBLIC ngcore ${PYTHON_LIBRARIES})
  set_target_properties(pyngcore PROPERTIES INSTALL_RPATH "${NG_RPATH_TOKEN}/${NETGEN_PYTHON_RPATH}")
  install(TARGETS pyngcore DESTINATION ${NG_INSTALL_DIR_PYTHON} COMPONENT netgen)
endif(USE_PYTHON)

=== libsrc/csg/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
add_library(csg ${NG_LIB_TYPE}
        algprim.cpp brick.cpp   
        bspline2d.cpp csgeom.cpp csgparser.cpp curve2d.cpp edgeflw.cpp	       
        explicitcurve2d.cpp extrusion.cpp gencyl.cpp genmesh.cpp identify.cpp  
        manifold.cpp meshsurf.cpp polyhedra.cpp revolution.cpp singularref.cpp 
        solid.cpp specpoin.cpp spline3d.cpp surface.cpp triapprox.cpp zrefine.cpp 
        python_csg.cpp splinesurface.cpp
        )
if(APPLE)
    set_target_properties( csg PROPERTIES SUFFIX ".so")
endif(APPLE)

target_link_libraries(csg PUBLIC mesh ${PYTHON_LIBRARIES})
if(NOT WIN32)
  install( TARGETS csg ${NG_INSTALL_DIR})
endif(NOT WIN32)

target_link_libraries(csg PUBLIC ngcore)

if(USE_GUI)
    add_library(csgvis ${NG_LIB_TYPE} vscsg.cpp )
    if(NOT WIN32)
        target_link_libraries(csgvis csg visual)
        if(APPLE)
            set_target_properties( csgvis PROPERTIES SUFFIX ".so")
        endif(APPLE)
        install( TARGETS csgvis ${NG_INSTALL_DIR})
    endif(NOT WIN32)
endif(USE_GUI)

install(FILES
  algprim.hpp brick.hpp csgeom.hpp csg.hpp csgparser.hpp
  curve2d.hpp edgeflw.hpp explicitcurve2d.hpp extrusion.hpp
  gencyl.hpp geoml.hpp identify.hpp manifold.hpp meshsurf.hpp
  polyhedra.hpp revolution.hpp singularref.hpp solid.hpp
  specpoin.hpp spline3d.hpp splinesurface.hpp surface.hpp
  triapprox.hpp vscsg.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/csg COMPONENT netgen_devel
)

=== libsrc/geom2d/CMakeLists.txt ===
add_definitions(-DNGLIB_EXPORTS)
add_library(geom2d ${NG_LIB_TYPE} genmesh2d.cpp geom2dmesh.cpp geometry2d.cpp python_geom2d.cpp )
if(APPLE)
    set_target_properties( geom2d PROPERTIES SUFFIX ".so")
endif(APPLE)

target_link_libraries(geom2d mesh ${PYTHON_LIBRARIES})
if(NOT WIN32)
  install( TARGETS geom2d ${NG_INSTALL_DIR})
endif(NOT WIN32)

target_link_libraries(geom2d ngcore)

if(USE_GUI)
    add_library(geom2dvis ${NG_LIB_TYPE} vsgeom2d.cpp)
    if(NOT WIN32)
        target_link_libraries(geom2dvis geom2d)
        install( TARGETS geom2dvis ${NG_INSTALL_DIR})
    endif(NOT WIN32)
endif(USE_GUI)

install(FILES
  geom2dmesh.hpp geometry2d.hpp spline2d.hpp
  vsgeom2d.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/geom2d COMPONENT netgen_devel
)

=== libsrc/gprim/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
add_library(gprim INTERFACE)
set(sdir ${CMAKE_CURRENT_SOURCE_DIR})
target_sources(gprim INTERFACE
        ${sdir}/adtree.cpp ${sdir}/geom2d.cpp ${sdir}/geom3d.cpp ${sdir}/geomfuncs.cpp
        ${sdir}/geomtest3d.cpp ${sdir}/transform3d.cpp ${sdir}/spline.cpp ${sdir}/splinegeometry.cpp
        )

install(FILES
  adtree.hpp geom2d.hpp geom3d.hpp geomfuncs.hpp geomobjects2.hpp
  geomobjects.hpp geomops2.hpp geomops.hpp geomtest3d.hpp gprim.hpp
  splinegeometry.hpp spline.hpp transform3d.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/gprim COMPONENT netgen_devel
)

=== debian/changelog ===
netgen (6.2.2006+really6.2.1905+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/4fad6e0631718a4bb574d67505e0ebfef1f171ce.patch:
    - upstream fix for armhf build failure (Closes: #984439)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 02 Apr 2021 14:05:03 +0200

=== debian/control ===
Source: netgen
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kurt Kremitzki <kkremitzki@debian.org>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libtool,
               tcl-dev,
               tk-dev,
               tix-dev,
               docbook-to-man,
               libxmu-dev,
               libglu1-mesa-dev,
               libmetis-dev,
               libocct-data-exchange-dev,
               libocct-foundation-dev,
               libocct-modeling-algorithms-dev,
               libocct-visualization-dev,
               libocct-ocaf-dev,
               libopenmpi-dev,
               libtogl-dev,
               libswscale-dev,
               libjpeg-dev,
               libbz2-dev,
               pybind11-dev,
               python3-dev,
               python3-dbg,
               python3-numpy,
               python3-pytest,
               python3-tk
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/netgen
Vcs-Git: https://salsa.debian.org/science-team/netgen.git
Homepage: https://ngsolve.org

Package: netgen
Architecture: any
Depends: libnglib-6.2 (= ${binary:Version}),
         mpi-default-bin [!mips !mipsel !ppc64el],
         tix,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: netgen-doc
Description: Automatic 3d tetrahedral mesh generator
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format.  NETGEN contains modules
 for mesh optimization and hierarchical mesh refinement.

Package: netgen-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: netgen
Description: Automatic 3d tetrahedral mesh generator documentation
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format.  NETGEN contains modules
 for mesh optimization and hierarchical mesh refinement.
 .
 This package contains the user manual (in PDF format) and example
 files.

Package: libnglib-dev
Architecture: any
Section: libdevel
Depends: libnglib-6.2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnglib-6.2.1804
Replaces: libnglib-6.2.1804
Description: Automatic 3d tetrahedral mesh generator development files
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains the static libraries and header files.

Package: libnglib-6.2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic 3d tetrahedral mesh generator shared library
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains the shared libraries.

Package: netgen-headers
Architecture: any
Section: libdevel
Depends: libnglib-dev (= ${binary:Version}),
         ${misc:Depends}
Description: Automatic 3d tetrahedral mesh generator internal headers
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains internal headers.

Package: python3-netgen
Architecture: any
Section: python
Depends: libnglib-6.2 (= ${binary:Version}),
         python3-tk,
         ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: ${python3:Provides}
Description: Automatic 3d tetrahedral mesh generator Python 3 bindings
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains Python 3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with=python3 --buildsystem=cmake

export MACHINE=LINUX

extra_flags += \
	-DCMAKE_INSTALL_LIBDIR=usr/lib/${DEB_HOST_MULTIARCH}/netgen \
	-DNG_INSTALL_DIR_LIB:PATH=lib/$(DEB_HOST_MULTIARCH)/netgen \
	-DNG_INSTALL_DIR_INCLUDE:PATH=include/netgen \
	-DPYBIND_INCLUDE_DIR:PATH=/usr/include \
	-DUSE_OCC:BOOL=ON \
	-DUSE_SUPERBUILD:BOOL=OFF \
        -DUSE_NATIVE_ARCH:BOOL=OFF \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

disable_mpi_archs = mips mipsel ppc64el

ifeq (,$(filter $(DEB_HOST_ARCH),$(disable_mpi_archs)))
       extra_flags += \
       -DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -lmpi -fPIC \
                          -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
       -DUSE_MPI:BOOL=ON
else
       extra_flags += \
       -DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -fopenmp -fPIC \
                          -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
       -DUSE_MPI:BOOL=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	sed -i s/DEB_HOST_MULTIARCH/${DEB_HOST_MULTIARCH}/ debian/netgen.desktop

override_dh_auto_test:
	dh_auto_install
	cd tests/pytest && \
          PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
          LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
          python3 -m pytest

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/${DEB_HOST_MULTIARCH}/netgen

=== debian/tests/control ===
Test-Command: set -e ; cd "$AUTOPKGTEST_TMP" ; echo "Testing with python3:" ; python3 -c "import netgen; print(netgen)"
Depends: python3, python3-netgen

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg\d*$//, repacksuffix=+dfsg1,uversionmangle=s/_/./g, filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/netgen-$1\.tar\.gz/" \
  https://github.com/ngsolve/netgen/tags .*/v?(\d\S+)\.tar\.gz

## netgen 6.2.2401%2Bdfsg1

=== libsrc/visualization/CMakeLists.txt ===
target_sources(nggui PRIVATE
    importsolution.cpp
    meshdoc.cpp
    mvdraw.cpp
    vsfieldlines.cpp
    vsmesh.cpp
    vssolution.cpp
    visualpkg.cpp
)
target_link_libraries( nggui PUBLIC "$<BUILD_INTERFACE:netgen_python>" ${MPI_CXX_LIBRARIES} ${OPENGL_LIBRARIES} nglib)

install(FILES
  meshdoc.hpp mvdraw.hpp visual_api.hpp
  vispar.hpp visual.hpp vssolution.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/visualization COMPONENT netgen_devel
)

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

include /usr/share/dpkg/architecture.mk

DEB_VERSION := $(shell dpkg-parsechangelog -S Version)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/[\.\+]dfsg.*$$//' )

# upstream script generate_version_file.cmake uses leading v
# use with tweak version 0 to trigger a short upstream version
NETGEN_VERSION = v$(DEB_STRIPPED_UPSTREAM_VERSION)-0

PY3DEF := $(shell py3versions -dv | sed "s/\.//")

%:
	dh $@ --with=python3 --buildsystem=cmake

export MACHINE=LINUX

extra_flags += \
	-DNETGEN_VERSION_GIT=$(NETGEN_VERSION) \
	-DNG_INSTALL_DIR_INCLUDE:PATH=include/netgen \
	-DPREFER_SYSTEM_PYBIND11=ON \
	-DBUILD_STUB_FILES=OFF \
	-DUSE_OCC:BOOL=ON \
	-DUSE_JPEG:BOOL=ON \
	-DUSE_MPEG:BOOL=ON \
	-DUSE_SUPERBUILD:BOOL=OFF \
	-DUSE_NATIVE_ARCH:BOOL=OFF \
	-DUSE_MPI:BOOL=ON \
	-DENABLE_UNIT_TESTS=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_RPATH=ON

execute_after_dh_clean:
	rm -rf tests/pytest/__pycache__ tests/pytest/.pytest_cache tests/pytest/*vol.gz

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	sed -i s/DEB_HOST_MULTIARCH/${DEB_HOST_MULTIARCH}/ debian/netgen.desktop

ifneq ($(DEB_HOST_ARCH),amd64)
# this subset of demo tests (test_tutorials.py::test_geoFiles)
# only passes on amd64
    SKIP_TEST_LIST += boxcyl.geo-mp11-5 cylsphere.geo-mp61-1 cylsphere.geo-mp64-4 \
	hinge.stl-mp99-5 part1.stl-mp129-1 part1.stl-mp132-4 \
	sculpture.geo-mp149-4 sphereincube.geo-mp168-5 \
	twobricks.geo-mp199-0 twobricks.geo-mp201-2 twobricks.geo-mp202-3 \
	twocubes.geo-mp205-0 twocubes.geo-mp207-2 twocubes.geo-mp208-3
endif

ifeq ($(DEB_HOST_ARCH),i386)
    SKIP_TEST_LIST += boxcyl.geo-mp10-4 hinge.stl-mp95-1 lense square
endif

override_dh_auto_test:
	dh_auto_install
	list_initialised=0; \
        for t in $(SKIP_TEST_LIST); do \
            if [ $${list_initialised} = 0 ]; then \
                SKIP_TESTS=$$t; \
                list_initialised=1; \
            else \
                SKIP_TESTS="$${SKIP_TESTS} or $$t"; \
            fi; \
        done; \
        if [ "x$${SKIP_TESTS}" != "x" ]; then \
            SKIP_TESTS="not ( $${SKIP_TESTS} )"; \
        fi; \
        echo "skipping tests: $${SKIP_TESTS}"; \
	cd tests/pytest && \
          PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
          LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
          python3 -m pytest -v -k "$${SKIP_TESTS}"

execute_after_dh_python3-arch:
	for pylib in libngpy libngguipy; do \
	  pylib_dh=`basename debian/python3-netgen/usr/lib/python3/dist-packages/netgen/$${pylib}*$(PY3DEF)*.so`; \
	  sed "s|netgen/$${pylib}.so|netgen/$${pylib_dh}|" -i debian/libnglib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/netgen/netgen-targets-relwithdebinfo.cmake; \
	done

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/${DEB_HOST_MULTIARCH}/netgen
